Subject: Re: [PATCHv2 2/7] revision.h: introduce blob/tree walking in order of the commits

From: Junio C Hamano <[email-masked]>
Date: Thu, 02 Nov 2017 10:20:12 +0900

Johannes Schindelin <[email-masked]> writes:

>> > Given that the test_expect_* functions evaluate the code, it makes me
>> > wonder whether those `return` statements really return appropriately, or
>> > one call level too low.
>> 
>> The test_expect functions eval the actual snippets inside a dummy
>> function. This is intentional exactly to allow them to call "return" at
>> will.
>
> Tricksy. And a bit unintuitive for script kings such as myself, but okay.

Exactly.

The hidden assumption on the way how "return" interacts with
the way we use "eval" is the reason why I said "Ugly? Yes, Correct?
Questionable" in the first place.